From 83c49fa2130cfb050a213d9fa3840e418ece2f6a Mon Sep 17 00:00:00 2001
From: Sebastian Poeplau <sebastian.poeplau@eurecom.fr>
Date: Tue, 18 Dec 2018 13:40:15 +0100
Subject: [PATCH] Log all queries that claripy sends to Z3

---
 claripy/backends/backend_z3.py | 19 +++++++++++++------
 1 file changed, 13 insertions(+), 6 deletions(-)

diff --git a/claripy/backends/backend_z3.py b/claripy/backends/backend_z3.py
index f4a85f0..b7f4ea6 100644
--- a/claripy/backends/backend_z3.py
+++ b/claripy/backends/backend_z3.py
@@ -535,6 +535,13 @@ class BackendZ3(Backend):
         _add_memory_pressure(1024 * 1024 * 10)
         return s
 
+    @staticmethod
+    def check(solver):
+        with open("/tmp/claripy.log", "a") as f:
+            f.write(solver.to_smt2() + "\n\n")
+
+        return solver.check()
+
     def _add(self, s, c, track=False):
         if track:
             for constraint in c:
@@ -585,7 +592,7 @@ class BackendZ3(Backend):
 
             l.debug("Doing a check!")
             #print "CHECKING"
-            if solver.check() != z3.sat:
+            if self.check(solver) != z3.sat:
                 return False
 
             if model_callback is not None:
@@ -618,7 +625,7 @@ class BackendZ3(Backend):
         for i in range(n):
             solve_count += 1
             l.debug("Doing a check!")
-            if solver.check() != z3.sat:
+            if self.check(solver) != z3.sat:
                 break
             model = solver.model()
 
@@ -674,7 +681,7 @@ class BackendZ3(Backend):
 
             solve_count += 1
             l.debug("Doing a check!")
-            if solver.check() == z3.sat:
+            if self.check(solver) == z3.sat:
                 l.debug("... still sat")
                 if model_callback is not None:
                     model_callback(self._generic_model(solver.model()))
@@ -697,7 +704,7 @@ class BackendZ3(Backend):
             solver.push()
             solver.add(expr == lo)
             l.debug("Doing a check!")
-            if solver.check() == z3.sat:
+            if self.check(solver) == z3.sat:
                 if model_callback is not None:
                     model_callback(self._generic_model(solver.model()))
                 vals.add(lo)
@@ -736,7 +743,7 @@ class BackendZ3(Backend):
 
             solve_count += 1
             l.debug("Doing a check!")
-            if solver.check() == z3.sat:
+            if self.check(solver) == z3.sat:
                 l.debug("... still sat")
                 lo = middle
                 vals.add(self._primitive_from_model(solver.model(), expr))
@@ -758,7 +765,7 @@ class BackendZ3(Backend):
             solver.push()
             solver.add(expr == hi)
             l.debug("Doing a check!")
-            if solver.check() == z3.sat:
+            if self.check(solver) == z3.sat:
                 if model_callback is not None:
                     model_callback(self._generic_model(solver.model()))
                 vals.add(hi)
-- 
2.23.0

